#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <unistd.h>
#include <regex.h>

#include "mime.h"

struct mimetype
{
	char *ruc;
	char *mime;
};

static struct mimetype table[] =
{
  { "html$", "text/html" },
  { "htm$", "text/html" },
  { "gif$", "image/gif" }, 	/* evil. */
  { "jpeg$", "image/jpeg" },
  { "jpg$", "image/jpeg" },
  { "png$", "image/png" },
  { "wav$", "audio/x-wav" },
  { NULL, NULL }
};

char *plaintext = "text/plain";

int
regex (char *r, char *s)
{
  void *preg;
  regmatch_t *pmatch;
  int val = 0;

  preg = (void *) malloc (1000 * sizeof (void *));
  pmatch = (regmatch_t *) malloc (1000 * sizeof (regmatch_t));

  regcomp (preg, r, 0);

  if (regexec (preg, s, strlen (s), pmatch, 0) == 0)
    val = 1;

  regfree (preg);
  return val;
}


char *
mime_find(char *filename)
{
	int x = 0;
	while(table[x].mime!=NULL)
	{
		if(regex(table[x].ruc,filename)==1)
			return table[x].mime;
		x++;
	}
	return plaintext;
}

void
mime_announce(int socket, char *filename)
{
	write(socket, "Content-Type: ",14);
	write(socket, mime_find(filename), strlen(mime_find(filename)));
	write(socket,"\n\n",2);
}


